/* HumblePatientDetailView */

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.testingthought.humble.ui.PatientDetailView;

public class HumblePatientDetailView extends PatientDetailView {

    public NSTextField patientDisplay; /* IBOutlet */
	
	// Initialization
	public void awakeFromNib() {
		app().note(this);
		displayPlaceholder();
	}
	
	
	// Calls from Presenter
	public void setHeading(String heading) {
		makeDisplayReadyForData();
		patientDisplay.setStringValue(heading + "\n\n" + 
		                              "data data data data\n" +
									  "data\n" +
									  "data data data data data\n" + 
									  "and more data");
	}

	// This is true because there's no other panel on the screen.
	public boolean isYourWindowActive() {
		return true;
	}
	
	public void makeYourWindowActive() {
	}
	

	// Util

	private void displayPlaceholder() {
		makeDisplayUnobtrusive();
		patientDisplay.setStringValue("No patient has been selected.");
	}

	private void makeDisplayUnobtrusive() {
		patientDisplay.setTextColor(NSColor.grayColor());
		patientDisplay.setAlignment(NSText.CenterTextAlignment);
		patientDisplay.setFont(NSFont.fontWithNameAndSize("Times-Roman", 16));
	}

	private void makeDisplayReadyForData() {
		patientDisplay.setTextColor(NSColor.blackColor());
		patientDisplay.setAlignment(NSText.LeftTextAlignment);
		patientDisplay.setFont(NSFont.fontWithNameAndSize("Times-Roman", 14));
	}

}
