package com.testingthought.humble.fixtures.dofixtures;

import fit.DoFixture;
import fit.Parse;
import com.testingthought.humble.ui.InpatientPresenter;
import com.testingthought.humble.ui.PatientDetailPresenter;
import com.testingthought.humble.ui.Application;
import com.testingthought.humble.fixtures.mocks.MockPatientDetailView;
import com.testingthought.humble.fixtures.mocks.MockInpatientView;


public class InteractionDesign extends DoFixture {

    public InteractionDesign() {
        app().note(new MockPatientDetailView());
        app().note(new MockInpatientView());
        assert app().isReady();
        inpatientView().addCase("Betsy", "Rankin");
    }


    // navigation between contexts
    public void theStartingContextIs(String contextName) {
        assert contextName.equals("inpatient"); // all that's needed so far
        app().setInteractionContextTo(inpatientPresenter());
    }

    public void navigateToTheContext(String contextName) {
    }

    public String theContextBecomes(String ContextName) {
        return "some visibility";
    }

    // inpatient context
    public void choosePatientWithOwner(String animalName, String ownerName) {
        inpatientView().choosePatientWithOwner(animalName, ownerName);
    }

    // patient detail context
    public String thePatientDetailContextNames() {
        return patientDetailPresenter().getAnimalName();
    }

    public String thePatientDetailContextShows() {
        return "should return a record";
    }

    public void chooseToEnterANewRecord() {
    }

    public String bothTheContextAndTheContextAre(
            String firstContext, String secondContext) {
        return "some visibility";
    }

    // soap entry context
    public void recordThatTheAnimalIs(
            String threeCharacteristics) {
    }

    public void recordThatItsTemperatureIs(String value) {
    }

    public void indicateThatTheSOAPIsFinished() {
    }

    // Shorthand

    private Application app() {
        return Application.getInstance();
    }

    private MockInpatientView inpatientView()  {
        return (MockInpatientView) app().getInpatientView();
    }

    private InpatientPresenter inpatientPresenter() {
        return app().getInpatientPresenter();
    }

    private MockPatientDetailView patientDetailView()  {
        return (MockPatientDetailView) app().getPatientDetailView();
    }

    private PatientDetailPresenter patientDetailPresenter() {
        return app().getPatientDetailPresenter();
    }

    // aliases for check - this is a clever hack due
    // to Rick Mugridge.
    public void now(Parse cells) throws Exception {
       check(cells);
    }

    public void noteThat(Parse cells) throws Exception {
        check(cells);
    }
}
