package com.testingthought.humble.fixtures.mocks;

import com.testingthought.humble.ui.*;

import java.util.ArrayList;
import java.util.List;

public class MockInpatientView extends InpatientView {
    private boolean wasARowHighlighted = false;
    private int highlightedRowIndex;
    private boolean wasTableRefreshed = false;
    private boolean myWindowIsActive = false;
    private boolean wasTheAnimalNameFieldEmptied = false;
    private boolean wasTheOwnerNameFieldEmptied = false;
    private ArrayList addCaseCommands = new ArrayList();


    // Higher-level utilities - called by Fit tests.
    public void addCase(String animalName, String ownerName) {
        animalNameEntered(animalName);
        ownerNameEntered(ownerName);
        addCasePressed();
    }

    public void choosePatientWithOwner(String animalName, String ownerName) {
        int index = myPresenter().indexForCase(animalName, ownerName);
        myPresenter().selectCase(index);
    }

    // Commands from the presenter.
    public void refresh() {
        wasTableRefreshed = true;
    }

    public boolean wasTableRefreshed() {
        return wasTableRefreshed;
    }


    public void highlightRow(int row) {
        highlightedRowIndex = row;
        wasARowHighlighted = true;
    }

    public int getHighlightedRowIndex() {
        return highlightedRowIndex;
    }

    public boolean wasARowHighlighted() {
        return wasARowHighlighted;
    }


    public void makeYourWindowActive() {
        myWindowIsActive = true;
    }

    public boolean isYourWindowActive() {
        return myWindowIsActive;
    }



    public void allowAddCase() {
        addCaseCommands.add("allowed");
    }

    public void disallowAddCase() {
        addCaseCommands.add("disallowed");
    }

    public List getAddCaseCommands() {
        return addCaseCommands;
    }


    public void emptyAnimalNameField() {
        wasTheAnimalNameFieldEmptied = true;
    }

    public void emptyOwnerNameField() {
        wasTheOwnerNameFieldEmptied = true;
    }

    public boolean wasTheAnimalFieldNameEmptied() {
        return wasTheAnimalNameFieldEmptied;
    }

    public boolean wasTheOwnerNameFieldEmptied() {
        return wasTheOwnerNameFieldEmptied;
    }


    // Util
    private InpatientPresenter myPresenter() {
        return Application.getInstance().getInpatientPresenter();
    }
}
