/**
 * Created by IntelliJ IDEA.
 * User: marick
 * Date: Apr 1, 2005
 * Time: 6:11:15 PM
 * To change this template use File | Settings | File Templates.
 */
package com.testingthought.humble.ui;


public class Application {
    private static Application ourInstance = new Application();
    private InpatientView inpatientView = null;
    private InpatientPresenter inpatientPresenter = null;
    private PatientDetailView patientDetailView = null;
    private PatientDetailPresenter patientDetailPresenter = null;

    public InpatientPresenter getInpatientPresenter() {
        return inpatientPresenter;
    }

    public PatientDetailView getPatientDetailView() {
        return patientDetailView;
    }

    public PatientDetailPresenter getPatientDetailPresenter() {
        return patientDetailPresenter;
    }

    public InpatientView getInpatientView() {
        return inpatientView;
    }


    // Singleton (boo!)
    public static Application getInstance() {
        return ourInstance;
    }

    private Application() {
        this.inpatientPresenter = new InpatientPresenter();
        this.patientDetailPresenter = new PatientDetailPresenter();
    }

    public static void forgetInstance() {
        ourInstance = new Application();
    }


    // Wiring presenters and views
    public void note(InpatientView inpatientView) {
        this.inpatientView = inpatientView;
        this.inpatientPresenter.readyView();
    }

    public void note(PatientDetailView patientDetailView) {
        this.patientDetailView = patientDetailView;
    }

    public boolean isReady() {
        return allMockableUIObjectsSupplied();
    }

    private boolean allMockableUIObjectsSupplied() {
        return inpatientView != null
               && patientDetailView != null;
    }

    // Other
    public void setInteractionContextTo(Presenter presenter) {
        presenter.makeYourWindowActive();
    }
}
